unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Registry;

const RKey = 'Software\Bonanzas\SlowDecimalCalc';

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    bAdd: TSpeedButton;
    bSub: TSpeedButton;
    bMul: TSpeedButton;
    bDiv: TSpeedButton;
    bRound: TSpeedButton;
    Edit4: TEdit;
    bUpDown: TSpeedButton;
    bYZ: TSpeedButton;
    bXZ: TSpeedButton;
    SpeedButton1: TSpeedButton;
    bTrunc: TSpeedButton;
    procedure bAddClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure bSubClick(Sender: TObject);
    procedure bUpDownClick(Sender: TObject);
    procedure bYZClick(Sender: TObject);
    procedure bXZClick(Sender: TObject);
    procedure bMulClick(Sender: TObject);
    procedure bDivClick(Sender: TObject);
    procedure bRoundClick(Sender: TObject);
    procedure bTruncClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure SaveRegistry;
    procedure RestoreRegistry;
  end;

var
  Form1: TForm1;

implementation

uses DecimalCalculations;

{$R *.dfm}

procedure TForm1.bAddClick(Sender: TObject);
var d1, d2, d3: TDecimal;
begin
  SaveRegistry;
  d1 := Str2Decimal( Edit1.Text );
  d2 := Str2Decimal( Edit2.Text );
  d3 := DecimalAdd( d1, d2 );
  Edit3.Text := Decimal2Str( d3 );
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  RestoreRegistry;
end;

procedure TForm1.RestoreRegistry;
var R: TRegistry;
begin
  R := TRegistry.Create;
  TRY
    R.OpenKeyReadOnly( RKey );
    if R.ValueExists( 'X' ) then
    begin
      Edit1.Text := R.ReadString( 'X' );
      Edit2.Text := R.ReadString( 'Y' );
      Edit3.Text := R.ReadString( 'Z' );
      Edit4.Text := R.ReadString( 'R' );
    end;
  FINALLY
    R.Free;
  END;
end;

procedure TForm1.SaveRegistry;
var R: TRegistry;
begin
  R := TRegistry.Create;
  TRY
    R.OpenKey( RKey, TRUE );
    R.WriteString( 'X',   Edit1.Text );
    R.WriteString( 'Y',   Edit2.Text );
    R.WriteString( 'Z',   Edit3.Text );
    R.WriteString( 'R',   Edit4.Text );
  FINALLY
    R.Free;
  END;
end;

procedure TForm1.bSubClick(Sender: TObject);
var d1, d2, d3: TDecimal;
begin
  SaveRegistry;
  d1 := Str2Decimal( Edit1.Text );
  d2 := Str2Decimal( Edit2.Text );
  d3 := DecimalSub( d1, d2 );
  Edit3.Text := Decimal2Str( d3 );
end;

procedure TForm1.bUpDownClick(Sender: TObject);
var s: String;
begin
  s := Edit1.Text;
  Edit1.Text := Edit2.Text;
  Edit2.Text := s;
end;

procedure TForm1.bYZClick(Sender: TObject);
begin
  Edit2.Text := Edit3.Text;
end;

procedure TForm1.bXZClick(Sender: TObject);
begin
  Edit1.Text := Edit3.Text;
end;

procedure TForm1.bMulClick(Sender: TObject);
var d1, d2, d3: TDecimal;
begin
  SaveRegistry;
  d1 := Str2Decimal( Edit1.Text );
  d2 := Str2Decimal( Edit2.Text );
  d3 := DecimalMul( d1, d2 );
  Edit3.Text := Decimal2Str( d3 );
end;

procedure TForm1.bDivClick(Sender: TObject);
var d1, d2, d3: TDecimal;
begin
  SaveRegistry;
  d1 := Str2Decimal( Edit1.Text );
  d2 := Str2Decimal( Edit2.Text );
  d3 := DecimalDiv( d1, d2 );
  Edit3.Text := Decimal2Str( d3 );
end;

procedure TForm1.bRoundClick(Sender: TObject);
var d1, d3: TDecimal;
    i: Integer;
begin
  SaveRegistry;
  d1 := Str2Decimal( Edit1.Text );
  i := StrToInt( Edit4.Text );
  d3 := DecimalRound( d1, i );
  Edit3.Text := Decimal2Str( d3 );
end;

procedure TForm1.bTruncClick(Sender: TObject);
var d1, d3: TDecimal;
    i: Integer;
begin
  SaveRegistry;
  d1 := Str2Decimal( Edit1.Text );
  i := StrToInt( Edit4.Text );
  d3 := DecimalTrunc( d1, i );
  Edit3.Text := Decimal2Str( d3 );
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
var d1, d3: TDecimal;
begin
  SaveRegistry;
  d1 := Str2Decimal( Edit1.Text );
  d3 := DecimalRoot( d1 );
  Edit3.Text := Decimal2Str( d3 );
end;

end.
